#ifdef USELIBNDS
#include <nds.h>
#else
#include <mininds/mininds.h>
#endif
#include <stdio.h>

#define NDSFN "/boot.nds"

#define VERSION "v1.1"

int generictwlpayload_main(void);

char strbuf[0x4000];
vu32 boot_flg = 0;
#ifdef TWLDEBUG
void printhandler(void *addr, void * userdata)
{
	char buf[256];

	if((u32)addr!=0x544f42)
	{
		DC_InvalidateRange(addr, 0x100);
		memset(buf, 0, 0x100);
		strncpy(buf, (char*)addr, 0xff);
		strncat(strbuf, buf, 0x3fff);
		strncat(strbuf, "\n", 0x3fff);
	}
	else
	{
		boot_flg = 1;
		#ifdef USELIBNDS
		fifoSendValue32(FIFO_USER_01,1);
		#else
		mininds_sendfifodata(FIFO_USER_01,1);
		#endif
	}
}

void mini_printhandler(u32 data)
{
	printhandler((void*)data, 0);
}
#endif

char argv0[256] = "sd:/boot.nds";

int main(void) {
	int printi;
	char *argv[1];
	argv[0] = argv0;
	char str[256];

	consoleDemoInit();
	//defaultExceptionHandler();
	
	memset(strbuf, 0, 0x4000);
	#ifdef TWLDEBUG
	#ifdef USELIBNDS
	//fifoSetDatamsgHandler(FIFO_USER_01, printhandler, 0);
	fifoSetAddressHandler(FIFO_USER_01, printhandler, 0);
	#else
	mininds_setfifochanhandler(FIFO_USER_01, mini_printhandler);
	#endif
	#endif

	printf("Version: " VERSION "\n\n");
	printf("Initializing sdmmc, insert SD card if not already inserted.\n\n");

	while(1) {

		REG_IME = 0;
		if(strbuf[0])
		{
			#ifdef USELIBNDS
			fifoSendValue32(FIFO_USER_01,1);
			#else
			mininds_sendfifodata(FIFO_USER_01,1);
			#endif
			printf("%s\n", strbuf);
			#ifdef WIFITWLDEBUG
			upload_datawifi((u8*)strbuf, strlen(strbuf));
			#endif
			memset(strbuf, 0, 0x4000);
		}
		REG_IME = 1;

		if(boot_flg)
		{
			printf("Booting...\n");
			generictwlpayload_setargv(1, argv);
			generictwlpayload_main();
		}

		swiWaitForVBlank();
	}

	return 0;
}
